
// Simple Stream Library for HP49g+

//& ****************************************************************************
//&
//& Written by Ingo Blank, September 2004
//& 
//& Copyright (C) 2004 The HP-GCC Development Team
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************

#include "hpstdio.h"
#include "hpstdlib.h"
#include "kos.h"

extern OPEN_LIST_ENTRY *__open_file_list;
extern int _exit_lock;

int fclose(FILE *f)
{
    int r;
    
    // open file list handling < ibl ; 2005-02-06 >
    
    if ( ! _exit_lock ) {
        
        OPEN_LIST_ENTRY *p,*q;
        
        p = __open_file_list;
        q = NULL;
        
        while(p) {
            if (p->file->handle == f->handle) break;
            q = p;
            p = p->next;
        }
        
        if (p) {    
            
            if (q == NULL)  
                // head element
                __open_file_list = p->next;
            else 
                // tail element
                q->next = p->next;
            
            free(p);
        }
    }
    
    
    
    r = kos_fclose(f->handle);
    free(f);
    return r;
}



