#include "syscall.h"
#include "kos.h"
#include <hpsys.h>

void kos_KillBeep(void)
{
    syscallArg0(StopBeepEntry);
}

BOOL kos_CheckBeepEnd(void)
{
    return (U32)syscallArg0(CheckBeepEndEntry);
}

S32 kos_beep(U32 freq, TIME_T time, U32 override)
{
    int retval;
    
     // parameters just work correctly @ 75 MHz < ibl ; 2004-10-28 >
     // ... hence I introduced a speed inquiry function < ibl ; 2005-11-14 >
    
    int was_slow ;
    
    if ((was_slow = sys_is_slowOn()))
        sys_slowOff();
    
    if((retval=syscallArg3(beepEntry, (U32)freq, (U32)time, (U32)override)) == SUCCESS)
        while(kos_CheckBeepEnd() == FALSE);
        
    if (was_slow)
        sys_slowOn();
    
    return retval;
}
