//& ****************************************************************************
//&
//& Written by Ingo Blank, October 2004
//& 
//& Copyright (C) 2004 The HP-GCC Development Team
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************

#include "hpstdlib.h"
#include "kos.h"




static ULONGLONG __w = 0LL;

void
srand_mwc(unsigned int seed)
{
    
    __w = seed ?  seed : sys_RTC_seconds() * kos_GetSysTickTime();
}

// optimized version, avoids calling of library functions (performs natively on ARM CPU)
// < ibl ; 2005-05-06 >

unsigned int
mwc(int bits)
{
    
    if(__w == 0LL)
        srand_mwc(0);
    
    __w = 1517746329LL * (unsigned int) __w + (__w >> 32);
    return (unsigned int)__w >> (32-bits);
}

/*
unsigned int
mwc(int bits)
{
    
    if(__w == 0LL)
        srand_mwc(0);
    
    __w = 1517746329 * (__w & 0xFFFFFFFF) + (__w >> 32);
    return (__w & 0xFFFFFFFF) >> (32-bits);
}
*/


