//& <prolog>
//& ****************************************************************************
//&
//& Written by Ingo Blank & Claudio Lapilli
//&
//& Copyright (C) 2005 HP-GCC Development Team
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************

//& </prolog>

// $Header: /cvsroot/hpgcc/sources/hplib/saturn/sat_dir_rclobject.c,v 1.3 2005/05/18 19:27:25 iblank Exp $

#include <hpgcc49.h>





/*!
    \fn        SAT_OBJ_DSCR * sat_dir_rclobject(char *path)
    \brief    Similar to sat_dir_getobject, but with \b RCL semantics.
            I.e. if the object is not found in the cureent dir, the search continues
            up the path towards root.
*/

SAT_OBJ_DSCR
* sat_dir_rclobject(char *path)
{
    char *base,*dir;
    int dif=1;
    
    
    if (*path == '/' || !strncmp(path,"HOME",4)) // no absolute pathes allowed for RCL
        return sat_dir_getobject(path);
    
    SAT_DIR_NODE *p = _sat_dir_getcwd();
    
    _sat_dir_split_path(path,&dir,&base);
    
    if(dir) 
        if(!(p = _sat_find_path(dir)))
            return NULL;
        
    SAT_DIR_ENTRY *q = NULL;
        
    while(p) {
        
        q = p->object;
        
        while(q && (dif = strcmp(q->sat_obj->name,base))) 
            q = q->next;
        
        if (dif)
            p = p->parent;
        else
            break;
    }
    
    free(base);
    free(dir);
    
    return dif ? NULL : q->sat_obj;
}


