//@<head>
//& <prolog>
//& ****************************************************************************
//&
//& Written by Claudio Lapilli, Sept 2005
//&
//& Copyright (C) 2004 HP-GCC Development Team
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************

//& </prolog>

// $Header: /cvsroot/hpgcc/sources/hplib/saturn/sat_memmove.c

#include <hpgcc49.h>

//@</head>

//@<func name="sat_memmove">
void
sat_memmove(int satsrc,int satdest,int nibbles)
{
    
    // SATURN MOVEUP/MOVEDOWN IMPLEMENTATION
    
    int src=satsrc;
    int offset=satdest-satsrc,add;
	if(offset>0) {
	// MOVEUP
    src+=nibbles-8;
	add=-8;
	}
	else add=8;		// MOVEDOWN

    while(nibbles>=8) {
        sat_poke(src+offset,sat_peek(src,8),8);
        src+=add;
        nibbles-=8;
    }
    if(nibbles) {
		if(add<0) src+=8-nibbles;
		sat_poke(src+offset,sat_peek(src,nibbles),nibbles);
	}
}
//@</func>
