//@<head>
//& <prolog>
//& ****************************************************************************
//&
//& Written by Claudio Lapilli, Sept 2005
//&
//& Copyright (C) 2005 HP-GCC Development Team
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************

//& </prolog>

// $Header: /cvsroot/hpgcc/sources/hplib/saturn/sat_shrinklastob.c

#include <hpgcc49.h>




// AUXILIARY FUNCTION, RETURNS THE AMOUNT OF USEABLE TEMPOB IN NIBBLES

extern int sat_getfreetempob();


//@</head>

//@<func name="sat_shrinklastob">
int
sat_shrinklastob(int objaddr,int newsize)
{
    
    // Shrink$ IMPLEMENTATION
	// can also work as Stretch$
    // newsize=size of object including prolog
    // in nibbles
	// WARNING: CAN BE USED ONLY ON LAST OBJECT IN TEMPOB

    
    int ttop=sat_peek(SAT_TEMPTOP,5);
    int rstk=sat_peek(SAT_RSKTOP,5);
    int size=rstk-ttop;
    int offset=ttop-(objaddr+newsize+5);
    int ptr,freemem;

	if(offset<0) {
	// stretch object
	freemem=sat_getfreetempob();
	if((-offset)>freemem) return FALSE;		// NOT ENOUGH MEMORY TO STRETCH OBJECT
	}

    // make room in memory
    sat_memmove(ttop,objaddr+newsize+5,size);
    
    // adjust tempob chain
    
    ptr=objaddr+newsize;
    sat_poke(ptr,newsize+6,5);
    
    // adjust pointers
    
    // RSKTOP
    sat_poke(SAT_RSKTOP,rstk-offset,5);
    
    // TEMPTOP
    sat_poke(SAT_TEMPTOP,ttop-offset,5);
    
    // adjust free memory
    freemem=sat_peek(SAT_DSKTOP,5)-sat_peek(SAT_RSKTOP,5);
    freemem/=5;
    sat_poke(SAT_AVMEM,freemem,5);
    
    // return addr to prolog of new object
    return TRUE;

}
//@</func>


