//&<prolog>
//& ****************************************************************************
//&
//& Written by Ingo Blank,  August 2005
//& 
//& Copyright (C) 2004,2005 Ingo Blank
//&
//& ****************************************************************************
//&
//&
//& This file is part of HP-GCC.
//&
//& HP-GCC is free software; you can redistribute it and/or modify
//& it under the terms of the GNU General Public License as published by
//& the Free Software Foundation; either version 2, or (at your option)
//& any later version.
//& 
//& HP-GCC is distributed in the hope that it will be useful,
//& but WITHOUT ANY WARRANTY; without even the implied warranty of
//& MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//& GNU General Public License for more details.
//& 
//& You should have received a copy of the GNU General Public License
//& along with HP-GCC; see the file COPYING. 
//&
//& As a special exception, you may use this file as part of a free software
//& library without restriction.  Specifically, if other files instantiate
//& templates or use macros or inline functions from this file, or you compile
//& this file and link it with other files to produce an executable, this
//& file does not by itself cause the resulting executable to be covered by
//& the GNU General Public License.  This exception does not however
//& invalidate any other reasons why the executable file might be covered by
//& the GNU General Public License.
//&
//& ****************************************************************************
//&</prolog>

// $Header: sat_stack_pop_stdargs.c , 2005-08-22 03:42:38 , ingo  $

#include <hpgcc49.h>

int
_sat_stack_pop_stdargs(const char *arg0, char ***argv)
{

    char **_argv;
    unsigned stack = sat_stack_init();
    int arg_start = 0;
    
    int  argc = sat_stack_depth();
    
    if (arg0) {
        argc++;
        arg_start = 1;
    }
    
    if (argc) {
    
        _argv = (char **) sys_chkptr(calloc(argc,sizeof(char *)));
        int i;
        
        for (i = argc-1 ; i >= arg_start; i--) 
            _argv[i] = str_unquote(sat_stack_pop_string_alloc(),'\'');
    
        if (arg_start)
            _argv[0] = arg0;
         
        *argv = _argv;

    }

    sat_stack_exit(stack);
    return argc;

    
}

int
sat_stack_pop_stdargs(char ***argv)
{
    return _sat_stack_pop_stdargs(NULL,argv);
}



