extern unsigned int *_mmu_table_addr,_mmu_table_entries;


// MAPS VIRTUAL <-> PHYSICAL
// WARNING: FOR RAM ONLY, DOES NOT TRANSLATE TO/FROM THE CODE SEGMENT


int sys_map_v2p(unsigned int vaddr)
{
    //translate virtual -> physical

    // NOT A VIRTUAL ADDRESS
    if( (vaddr>>20)!=0x011) return vaddr;
    return( (_mmu_table_addr[((vaddr&0x000ff000)>>12)]&0xfffff000)+(vaddr&0xfff) );
}

int sys_map_p2v(unsigned int paddr)
{
    //translate physical -> virtual
    int f;

    // ALREADY VIRTUAL ADDRESS
    if( (paddr>>20)==0x011) return paddr;
    
for(f=0;f<_mmu_table_entries;++f)
{
    if( (_mmu_table_addr[f]&0xfffff000)==(paddr&0xfffff000)) return(0x01100000+(f<<12)+(paddr&0xfff));
}

// ADDRESS IS NOT IN THE VIRTUAL TABLE, RETURN PHYSICAL ADDRESS UNCHANGED
return paddr;
}
